#include <util/delay.h>

#include "display.h"
#include "driver.h"
#include "library.h"

#include "init.h"

/*Zeigt Text "Entfernung" an und fhrt wait_ack Funtion aus*/
void text_entfernung(void)
{
	rs232_putchar(0x73);
	rs232_putchar(0x00);
	rs232_putchar(0x00);
	rs232_putchar(0x02);
	rs232_putchar(0xFF);
	rs232_putchar(0xFF);
	rs232_printf("Entfernung");
	rs232_putchar(0x00);
	wait_ack(1);
}

/*Zeigt Text "cm" an und fhrt wait_ack Funtion aus*/
void text_cm(void)
{
	rs232_putchar(0x73);
	rs232_putchar(0x00);
	rs232_putchar(0x01);
	rs232_putchar(0x02);
	rs232_putchar(0xFF);
	rs232_putchar(0xFF);
	rs232_printf("[cm]");
	rs232_putchar(0x00);
	wait_ack(2);
}

/*Zeigt den AD-Wert von 0-255 an*/
void distanz_analogwert(void)
{
	rs232_putchar(0x53);
	rs232_putchar(0x26);
	rs232_putchar(0x0E);
	rs232_putchar(0x02);
	rs232_putchar(0xFF);
	rs232_putchar(0xFF);
	rs232_putchar(0x02);
	rs232_putchar(0x01);
	rs232_putchar(analogwert[0]);
	rs232_putchar(analogwert[1]);
	rs232_putchar(analogwert[2]);
	rs232_putchar(analogwert[3]);
	rs232_putchar(0x00);
	wait_ack(3);
}

/*Zeigt die Distanz an*/
void distanz_entfernung(void)
{
	rs232_putchar(0x53);
	rs232_putchar(0x01);
	rs232_putchar(0x19);
	rs232_putchar(0x02);
	rs232_putchar(0xFF);
	rs232_putchar(0xFF);
	rs232_putchar(0x03);
	rs232_putchar(0x02);
	rs232_putchar(entfernung[0]);
	rs232_putchar(entfernung[1]);
	rs232_putchar('.');
	rs232_putchar(entfernung[2]);
	rs232_putchar(entfernung[3]);
	rs232_putchar(entfernung[4]);
	rs232_putchar(0x00);
	wait_ack(4);
}

/*Zeigt "Error" an*/
void error_anzeige(void)
{
	rs232_putchar(0x73);
	rs232_putchar(0x05);
	rs232_putchar(0x03);
	rs232_putchar(0x02);
	rs232_putchar(0xFF);
	rs232_putchar(0xFF);
	rs232_printf("ERROR");
	rs232_putchar(0x00);
	wait_ack(5);
}

/*Zeigt einen Balken in Bezug auf die Distanz an*/
void balken_funktion(void)
{
	rs232_putchar(0x72);
	rs232_putchar(0x00);
	rs232_putchar(50);
	rs232_putchar(balkenanzeige);
	rs232_putchar(0x3F);
	rs232_putchar(0xFF);
	rs232_putchar(0xFF);
	wait_ack(6);
}

void display_hintergrundfarbe(void)
{
  rs232_putchar (0x42);		//blauer Hintergrund
  rs232_putchar (0x00);
  rs232_putchar (0x1F);
  wait_ack (7);
}

/*Daten von serieller Schnittstelle fr das Display werden eingestellt*/
void auto_baud(void)
{
	rs232_putchar (0x55);
	wait_ack (8);
}

/*Lscht das Display*/
void display_loeschen(void)
{
  	rs232_putchar (0x45);		//Bildschirm lschen'
  	wait_ack (9);
}

/*Zeichnet einen Kreis*/
void display_kreis(void)
{
  int rad;

  for (rad = 0; rad < 30; rad = rad + 2)
    {
      _delay_ms (100);

      rs232_putchar (0x43);
      rs232_putchar (0x30);
      rs232_putchar (0x20);
      rs232_putchar (rad);
      rs232_putchar (0xFF);
      rs232_putchar (0xFF);

	  wait_ack (10);
    }
}
