#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>

#include "driver.h"
#include "display.h"
#include "library.h"

#include "init.h"

/*SPI senden und empfangen*/

unsigned char SPI_MasterTransmit( unsigned char cData)
{
  SPDR = cData;              // ein Byte wegschicken
  while(!(SPSR & (1<<SPIF))) // warten bis alles draussen ist
    ;                        // in der Zwischenzeit wird das Byte vom
                             // Slave empfangen
  return SPDR;               // das empfangene Byte zurckliefern
}

/*serielle Schnittstelle senden*/

void rs232_putchar (char buchstabe)
{
	while ( !( UCSR1A & (1<<UDRE1)) )
	;

	UDR1 = buchstabe;
}


/*serielle Schnittstelle empfangen*/

char rs232_getchar(void)
{
	int timer;

	timer=30;

	while ( (!(UCSR1A & (1<<RXC1))) && (timer>0)) 
	{
		_delay_ms(2);
		timer--;
	}
  if (timer==0) 
  {
	return 0;
  }
	return UDR1;
}


/*Bei seriellen Schnittstelle Zeichenkette schreiben*/
void rs232_printf (char *zeichen)
{
	while(*zeichen != '\0')
	{
		rs232_putchar(*zeichen);
		zeichen++;
	}
}



/*Bei Display auf das wait_ack warten. Wenn das Display != 0x06
zurck schickt soll die Display-Funktion noch einmal gesendet werden*/

void wait_ack(int funktionsnummer)
{
	char acknowledge;


	PORTB|= 0x40;
	
		
	PORTB |= 0x80;
		
	acknowledge = rs232_getchar();	
	
	if(acknowledge != 0x06)
	{
	//	rs232_putchar(0x00);
	//	wait_ack();
	//	rs232_putchar(0x45);
	//	wait_ack(9);
		funktion_aufrufen(funktionsnummer);
	}

	PORTB&= 0x7F;	
	
	PORTB &= 0xBF;
}



/*Wenn Timer-Interrupt ausgelst wird soll das Display gelscht,
der aktuelle Wert vom Sensor eingelesen und neuerwert_vorhanden=1 gesetzt 
werden um in der main()-Funktion vom sleep-Modus in Display aktualisieren
 Modus zu kommen.*/

ISR (TIMER1_COMPA_vect)
{

display_loeschen();

PORTB ^= (1<<PB5);

wert_einlesen();

neuerwert_vorhanden=1;


}

