#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "driver.h" 
#include "init.h"
#include "display.h"

#include "library.h"

/*ber SPI wird der adc_wert eingelesen. Mit dem adc_wert wird die 
richtige Distanz berechnet. Wenn adc_wert 0 oder 255 hat der Balken die 
Lnge 0 ansonsten die passende Lnge. adc_wert und distanz werden in
einen char-array umgewandelt fr die Displayausgabe.*/ 

void wert_einlesen(void)
{
  float spannung;	
  float distanz;
  int i;

  for(i=0; i<=2; i++)
  {
	  PORTB &= 0xFE; //  /CS auf 0 setzen

	  adc_wert= SPI_MasterTransmit('0');

	  PORTB |= 0x01;
  }

  spannung = ((float) 2.25*adc_wert)/255 + 0.4; 
  distanz = 15/(spannung + 0.05) - 1.5;
  
  if ((adc_wert==0) || (adc_wert==255))
  {
  	balkenanzeige = 0;
  }
  else
  {
	balkenanzeige = 3*distanz;
  }
	
	distanz = distanz*10;

  itoa (adc_wert, analogwert, 10);
  itoa (distanz, entfernung, 10);
}

/*Wenn in der Funktion wait_ack() ein Fehler bei der Displayausgabe 
erscheint wird die Displayfunktion wiederholt*/

void funktion_aufrufen(int funktionsnummer)
{
	if(funktionsnummer==1)
	{
		text_entfernung();
	}
	else if(funktionsnummer==2)
	{
		text_cm();
	}
	else if(funktionsnummer==3)
	{
		distanz_analogwert();
	}
	else if(funktionsnummer==4)
	{
		distanz_entfernung();
	}
	else if(funktionsnummer==5)
	{
		error_anzeige();
	}
	else if(funktionsnummer==6)
	{
		balken_funktion();
	}
	else if(funktionsnummer==7)
	{
		display_hintergrundfarbe();
	}
	else if(funktionsnummer==8)
	{
		auto_baud();
	}
	else if(funktionsnummer==9)
	{
		display_loeschen();
	}
	else if(funktionsnummer==10)
	{
		display_kreis();
	}
	else 
	{
		display_loeschen();
	}

}
